Subject: [PATCH v3 01/15] gnu: Add fast-float.

From: David Elsing <[email-masked]>
Date: Thu, 13 Oct 2022 21:04:10 +0000

* gnu/packages/cpp.scm (fast-float): New variable.
---
 gnu/packages/cpp.scm | 50 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 50 insertions(+)

diff --git a/gnu/packages/cpp.scm b/gnu/packages/cpp.scm
index 805413cc61..eba39ed660 100644
--- a/gnu/packages/cpp.scm
+++ b/gnu/packages/cpp.scm
@@ -29,6 +29,7 @@
 ;;; Copyright © 2022 muradm <[email-masked]>
 ;;; Copyright © 2022 Attila Lendvai <[email-masked]>
 ;;; Copyright © 2022 Arun Isaac <[email-masked]>
+;;; Copyright © 2022 David Elsing <[email-masked]>
 ;;;
 ;;; This file is part of GNU Guix.
 ;;;
@@ -1954,3 +1955,52 @@ (define-public crc32c
      "This package provides architecture-specific implementations of the
 CRC32C algorithm, which is specified in RFC 3720, section 12.1.")
     (license license:bsd-3)))
+
+(define-public fast-float
+  (package
+    (name "fast-float")
+    (version "3.5.1")
+    (source (origin
+              (method git-fetch)
+              (uri (git-reference
+                    (url "https://github.com/fastfloat/fast_float")
+                    (commit (string-append "v" version))))
+              (file-name (git-file-name name version))
+              (sha256
+               (base32
+                "0z3rxxd0pwvw70dbnv63rm67biw829vdqf50y16isxm6g3sbrz8g"))))
+    (build-system cmake-build-system)
+    (arguments
+     (list
+      #:configure-flags
+      #~(list
+         "-DFASTFLOAT_TEST=ON"
+         "-DSYSTEM_DOCTEST=ON")
+      #:phases
+      #~(modify-phases %standard-phases
+          (add-after 'unpack 'patch-cmake-tests
+            (lambda _
+              (substitute* "tests/CMakeLists.txt"
+                (("FetchContent_GetProperties\\(supplemental_test_files.*")
+                 "")
+                (("if\\(NOT supplemental_test_files_POPULATED.*")
+                 (string-append
+                  "set(supplemental_test_files_BINARY_DIR "
+                  #$(origin
+                      (method git-fetch)
+                      (uri (git-reference
+                            (url (string-append "https://github.com/fastfloat"
+                                                "/supplemental_test_files.git"))
+                            (commit "97a0b2e638feb479387554cf253e346500541e7e")))
+                      (file-name (git-file-name "fast_float_test-data" version))
+                      (sha256
+                       (base32
+                        "0dxbiyzyh7i847i89ablfzypfc3ckhm7f74w98jsh73v1mppmxlf")))
+                  "/data)\nif(0)\n"))))))))
+    (native-inputs (list doctest))
+    (home-page "https://github.com/fastfloat/fast_float")
+    (synopsis "Floating point number parser for C++")
+    (description "@code{fast_float} is a header-only C++ library for parsing
+floating point numbers from strings.  It implements the C++ from_chars
+functions for the float and double types.")
+    (license (list license:asl2.0 license:expat)))) ; dual licensed
-- 
2.37.0